/* Copyright (c) 2013 Rado1 */

package org.zgameeditor;

import android.content.Context;
import android.service.wallpaper.WallpaperService;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.util.Log;

public class ZgeWallpaperService extends WallpaperService {

	private static final String TAG = "ZGEWP";
		
	@Override
	public Engine onCreateEngine() {
		Log.i(TAG, "ZgeWallpaperService.onCreateEngine");
		return new GLEngine();
	}

	public class GLEngine extends Engine {
		class ZgeWallpaperSurfaceView extends Zge {

			ZgeWallpaperSurfaceView(Context context) {
				super(context);
				Log.i(TAG, "new ZgeWallpaperSurfaceView");
			}

			@Override
			public SurfaceHolder getHolder() {
				Log.i(TAG, "ZgeWallpaperSurfaceView.getHolder");
				return getSurfaceHolder();
			}

			public void onDestroy() {
				super.onDetachedFromWindow();
				Log.i(TAG, "ZgeWallpaperSurfaceView.onDestroy");
			}
		}

		private ZgeWallpaperSurfaceView glSurfaceView = null;

		@Override
		public void onCreate(SurfaceHolder surfaceHolder) {
			super.onCreate(surfaceHolder);
			glSurfaceView = new ZgeWallpaperSurfaceView(ZgeWallpaperService.this);
			setTouchEventsEnabled(true);
			Log.i(TAG, "GLEngine.onCreate");
		}

		@Override
		public void onVisibilityChanged(boolean visible) {
			super.onVisibilityChanged(visible);

			if (visible) {
				glSurfaceView.onResume();
			} else {
				glSurfaceView.onPause();
			}
			Log.i(TAG, "GLEngine.onVisibilityChanged");
		}

		@Override
		public void onDestroy() {
			super.onDestroy();
			glSurfaceView.onDestroy();
			Log.i(TAG, "GLEngine.onDestroy");
		}
		
		@Override
		public void onTouchEvent(MotionEvent event){
			glSurfaceView.onTouchEvent(event);
		}
	}
}